import java.awt.*;
import java.awt.datatransfer.*;
import java.io.*;

class Main {
    // getTransferData Example
    public static void main(String[] args) {
        int numRead;
        char buffer[] = new char[1024];
        PrintWriter out = new PrintWriter(System.out);

        // Retrieve handle to clipboard and contents
        Clipboard clipboard = 
            Toolkit.getDefaultToolkit().getSystemClipboard();
        Transferable t = clipboard.getContents(null);

        if (t == null) {
            // Clipboard is empty.
            return;    
        }

        try {
            // Retrieve as string flavor.
            String s = (String)t.getTransferData(
                DataFlavor.stringFlavor);
            System.out.println("Clipboard Contents = "+s);
    
            // Retrieve as plain text flavor.
            StringReader r = (StringReader)t.getTransferData(
                DataFlavor.plainTextFlavor);
            while ((numRead = r.read(buffer, 0, buffer.length)) >= 0) {
                out.write(buffer, 0, numRead);
            }
        } catch (IOException e) {
        } catch (UnsupportedFlavorException e) {
        }
    }
}
