import java.awt.*;
import java.awt.datatransfer.*;
import java.io.*;

class Main {
    public static void main(String[] args) {
        Clipboard clipboard = 
            Toolkit.getDefaultToolkit().getSystemClipboard();
        Transferable t = clipboard.getContents(null);

        if (t == null) {
            System.out.println("The clipboard is empty");
            System.exit(0);
        }
        try {
            String s = (String)t.getTransferData(DataFlavor.stringFlavor);

            System.out.println("-----------------------");
            System.out.println(s);
            System.out.println("-----------------------");
        } catch (IOException e) {
            System.out.println(
                "The data is no longer available in the string flavor");
        } catch (UnsupportedFlavorException e) {
            System.out.println(
                "The data is not available in the string flavor");
        }

        System.exit(0);
    }
}