import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ContainerListener, ActionListener {
    Main() {
        super("ContainerEvent Example");
        Button b = new Button("New Button");

        // Listen for events.
        b.addActionListener(this);
        addContainerListener(this);

        // Layout component
        setLayout(new FlowLayout());
        add(b);

        setSize(100, 100);
        show();
    }

    // Container event handler methods
    public void componentAdded(ContainerEvent evt) {
        System.out.println("COMPONENT_ADDED: "+evt.getChild());
        System.out.println("  There are now "
            +evt.getContainer().getComponentCount()+" children.");
    }
    public void componentRemoved(ContainerEvent evt) {
        System.out.println("COMPONENT_REMOVED: "+evt.getChild());
        System.out.println("  There are now "
            +evt.getContainer().getComponentCount()+" children.");
    }
    
    // This increasing number is used in naming the new buttons.
    int count;

    // Action event handler method
    public void actionPerformed(ActionEvent evt) {
        if (evt.getActionCommand().equals("New Button")) {
            // Add a button.
            Button b = new Button("Remove Me "+(count++));
    
            // Listen for events.
            b.addActionListener(this);
            add(b);
            validate(); // relayout container
        } else if (evt.getActionCommand().startsWith("Remove Me ")) {
            // Remove a button.
            remove((Component)evt.getSource());
            validate(); // relayout container
        }
    }

    public static void main(String args[]) {
        new Main();
    }
}
