import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    char curKeyChar;

    Main() {
        super("CHAR_UNDEFINED Example");

        // Listen for text events.
        addKeyListener(new KeyEventHandler());

        setSize(200, 100);
        setFont(new Font("Monospaced", Font.BOLD, 36));
        show();
    }

    public void paint(Graphics g) {
        Insets in = getInsets();
        FontMetrics fm = g.getFontMetrics();
        String s = "" + curKeyChar;

        if (curKeyChar != KeyEvent.CHAR_UNDEFINED) {
            g.drawString(s, (getSize().width-fm.stringWidth(s))/2, 
                in.top+(getSize().height-in.top-in.bottom-
                fm.getHeight())/2+fm.getAscent());
        }
    }

    class KeyEventHandler extends KeyAdapter {
        public void keyPressed(KeyEvent evt) {
            if (curKeyChar != evt.getKeyChar()) {
                curKeyChar = evt.getKeyChar();
                repaint();
            }
        }
        public void keyReleased(KeyEvent evt) {
            curKeyChar = KeyEvent.CHAR_UNDEFINED;
            repaint();
        }
    }
    
    public static void main(String args[]) {
        new Main();
    }
}
