import java.awt.*;
import java.awt.event.*;
import java.util.*;

class Main extends Frame {
    Hashtable macros = new Hashtable();
    TextArea ta = new TextArea();

    Main() {
        super("KeyEvent Example");
        
        // Initialize macro table.
        macros.put(new Integer(KeyEvent.VK_F1), "package");
        macros.put(new Integer(KeyEvent.VK_F2), "import");
        macros.put(new Integer(KeyEvent.VK_F3), "class");
        macros.put(new Integer(KeyEvent.VK_F4), "extends");
        macros.put(new Integer(KeyEvent.VK_F5), "implements\u0041");

        // Listen for key events
        ta.addKeyListener(new KeyEventHandler());

        add(ta, BorderLayout.CENTER);
        setSize(150, 200);
        show();
    }

    class KeyEventHandler extends KeyAdapter {
        public void keyTyped(KeyEvent evt) {
            System.out.println(evt);
        }
        public void keyPressed(KeyEvent evt) {
            System.out.println(evt);

            String s = (String)macros.get(new Integer(evt.getKeyCode()));

            if (s != null) {
                System.out.println(s);
                for (int i=0; i<s.length(); i++) {
                    KeyEvent ke = new KeyEvent(ta, KeyEvent.KEY_PRESSED, 0, 
                        0, s.charAt(i)/*KeyEvent.VK_UNDEFINED*/, s.charAt(i));
                    //ta.dispatchEvent(ke);
                    getToolkit().getSystemEventQueue().postEvent(ke);
                }
            }
            evt.consume();
        }
    }

    public static void main(String[] args) {
        new Main();
    }
}