import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Checkbox altCb = new Checkbox("alt");
    Checkbox controlCb = new Checkbox("control");
    Checkbox metaCb = new Checkbox("meta");
    Checkbox shiftCb = new Checkbox("shift");

    Main() {
        super("setModifiers Example");
        TextArea ta = new TextArea();
        
        add(ta, BorderLayout.CENTER);
        ta.addKeyListener(new KeyEventHandler());

        Panel p = new Panel(new FlowLayout());
        p.add(altCb);
        p.add(controlCb);
        p.add(metaCb);
        p.add(shiftCb);
        add(p, BorderLayout.SOUTH);

        setSize(300, 200);
        show();
    }

    class KeyEventHandler extends KeyAdapter {
        public void keyTyped(KeyEvent evt) {
            int mods = evt.getModifiers();
            char ch = evt.getKeyChar();

            if (altCb.getState()) {
                mods |= InputEvent.ALT_MASK;
            }
            if (controlCb.getState()) {
                mods |= InputEvent.CTRL_MASK;
                ch = (char)(Character.toUpperCase(ch) - 64);
                evt.setKeyChar((char)Math.max(0, ch));
            }
            if (metaCb.getState()) {
                mods |= InputEvent.META_MASK;
            }
            if (shiftCb.getState()) {
                mods |= InputEvent.SHIFT_MASK;
                evt.setKeyChar(Character.toUpperCase(ch));
            }
            evt.setModifiers(mods);
        }
    }

    public static void main(String[] args) {
        new Main();
    }
}
