import java.awt.peer.ActiveEvent;
import java.awt.*;

class Main extends Frame {
    public Main() {
        super("ActiveEvent Example");

        Label label = new Label("", Label.CENTER);
        add(label, BorderLayout.CENTER);
        setSize(200, 100);
        show();

        // Add active event to system event queue.
        EventQueue queue = getToolkit().getSystemEventQueue();
        queue.postEvent(new SampleActiveEvent("this is a test", label));
    }

    public static void main(String[] args) {
        new Main();
    }
}

class SampleActiveEvent extends AWTEvent implements ActiveEvent {
    static final int TESTEVENTMASK = AWTEvent.RESERVED_ID_MAX+100;
    Label label;
    String msg;

    SampleActiveEvent(String msg, Label l) {
        super(msg, TESTEVENTMASK);
        this.label = l;
        this.msg = msg;
    }

    public void dispatch() {
        label.setText(msg);
    }
}

