import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ItemListener, ActionListener {
    String[] styleNames = {"plain", "italic", "bold", "bold-italic"};
    int[] styleValues = {Font.PLAIN, Font.ITALIC, Font.BOLD, 
                         Font.ITALIC|Font.BOLD};
    Choice chFont = new Choice();
    Choice chStyle = new Choice();
    TextField tf = new TextField("Hello");

    Main() {
        super("Choice Example");
        Panel p = new Panel();

        // Retrieve all the font names.
        for (int i=0; i<getToolkit().getFontList().length; i++) {
            chFont.addItem(getToolkit().getFontList()[i]);
        }
        // Initialize the font style choice.
        for (int i=0; i<styleNames.length; i++) {
            chStyle.addItem(styleNames[i]);
        }
        p.setLayout(new GridLayout(1, 0));
        p.add(chFont);
        p.add(chStyle);

        // Listen for events on choices
        chFont.addItemListener(this);
        chStyle.addItemListener(this);

        // Listen for events on text field
        tf.addActionListener(this);

        add(p, BorderLayout.NORTH); 
        add(tf, BorderLayout.SOUTH); 
        setSize(300, 150);
        setVisible(true);
    }

    public void paint(Graphics g) {
        Insets insets = getInsets();
        int w = getSize().width-insets.left-insets.right-2;
        int h = getSize().height-insets.top-insets.bottom-2;
        Font f = new Font(chFont.getSelectedItem(), 
            styleValues[chStyle.getSelectedIndex()], 24);
        FontMetrics fm = g.getFontMetrics(f);
        String str = tf.getText();

        g.clearRect(0, 0, w, h);
        g.setFont(f);
        g.drawString(str, (w-fm.stringWidth(str))/2, 
            (h-fm.getHeight())/2+fm.getAscent());
    }

    // Update action for choice components
    public void itemStateChanged(ItemEvent e) {
        repaint();
    }

    // Update action for text field
    public void actionPerformed(ActionEvent e) {
        repaint();
    }

    static public void main(String[] args) {
        new Main();
    }
}
