import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    Choice choice = new Choice();
    Button removeBtn = new Button("Remove");
    Button removeAllBtn = new Button("RemoveAll");
    Button addBtn = new Button("Insert");
    int lastItemCount = 0;

    Main() {
        super("remove Example");

        // Initialize the choice with 10 items.
        for (int i=0; i<10; i++) {
            choice.addItem("item "+(lastItemCount++));
        }

        // Listen for events.
        removeBtn.addActionListener(this);
        addBtn.addActionListener(this);
        removeAllBtn.addActionListener(this);

        Panel p = new Panel(new GridLayout(1, 0));
        p.add(removeBtn); 
        p.add(removeAllBtn);
        p.add(addBtn);

        add(choice, BorderLayout.CENTER); 
        add(p, BorderLayout.NORTH); 
        setSize(300, 150);
        show();
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if (cmd.equals("RemoveAll")) {
            choice.removeAll();
        } else {
            int target = choice.getSelectedIndex();
            if (cmd.equals("Remove")) {
                if (target >= 0) {
                    choice.remove(target);
                }
                // else add
            } else {
                if (target >= 0) {
                    choice.insert("item "+(lastItemCount++), target);
                    choice.select(target);
                } else {
                    choice.add("item "+(lastItemCount++));
                }
            }
        }
        removeBtn.setEnabled(choice.getItemCount() > 0);
        removeAllBtn.setEnabled(choice.getItemCount() > 0);
    }

    static public void main(String[] args) {
        new Main();
    }
}
