import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    Circle c = new Circle(new Point(60, 60), 25);
    TextField textfield;

    Main() {
        super("getSize Example");

        Panel p = new Panel(new GridLayout(1, 0));
        p.add(new Label("radius"));
        p.add(textfield=new TextField("25"));
        textfield.addActionListener(this);

        add(p, BorderLayout.SOUTH);
        setSize(100, 150);
        show();
    }

    public void paint(Graphics g) {
        c.draw(g);
    }

    public void actionPerformed(ActionEvent evt) {
        Dimension orig = c.getSize();
        Dimension sz = orig.getSize(); // make copy
        int radius = Integer.parseInt(evt.getActionCommand());
        sz.setSize(radius*2, radius*2);
        if (sz.equals(orig)) {
            System.out.println("Radius unchanged");
        } else {
            c.setSize(sz);
        }
        repaint();
    }

    public static void main(String[] args) {
        new Main();
    }
}

class Circle {
    Point origin;
    int radius;

    Circle(Point origin, int radius) {
        this.origin = origin;
        this.radius = radius;
    }

    public Dimension getSize() {
        return new Dimension(2 * radius, 2 * radius);
    }

    public void setSize(Dimension d) {
        radius = d.width/2;
    }

    public void draw(Graphics g) {
        g.fillOval(origin.x-radius, origin.y-radius, 
                   getSize().width, getSize().height);
    }
}
