import java.awt.*;
import java.io.*;
import java.util.*;

class Main extends Frame {
    StringReader is = new StringReader("Hello\nWorld!\nHow are\nyou\ntoday?");
    int[] charWidths;

    Main() {
        super("getWidths Example");
        setFont(new Font("SansSerif", Font.PLAIN, 20));
        setSize(300, 200);
        show();
    }

    public void paint(Graphics g) {
        int x = getInsets().left, y = getInsets().top;
        int ch;
        char[] chs = new char[1];
        FontMetrics fm = g.getFontMetrics();

        if (charWidths == null) {
            charWidths = fm.getWidths();
        }

        try {
            is.reset();
            while ((ch = is.read()) != -1) {
                if (ch == '\n') {
                    x += fm.getMaxAdvance() + fm.getDescent();
                    y = getInsets().top;
                    continue;
                }
                chs[0] = (char)ch;
                g.drawChars(chs, 0, 1, 
                            x + (fm.getMaxAdvance()-charWidths[ch])/2, 
                            y + fm.getAscent());
                y += fm.getHeight();
            }
        } catch (IOException e) {
            System.err.println(e);
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
