import java.awt.*;
class Main extends Frame {
    Image image;

    Main(String filename) {
        super("drawImage Example");
        try {
            image = getToolkit().getImage(filename);
            setIconImage(image);
        } catch (Exception e) {
            e.printStackTrace();
        }

        setSize(400, 200);
        show();
    }

    public void paint(Graphics g) {
        Insets insets = getInsets();
        int x = insets.left, y = insets.top;
        int w = image.getWidth(this);
        int h = image.getHeight(this);
        
        // original
        g.drawImage(image, x, y, this);  

        // shrinken
        g.drawRect(x, y, w/4+1, h/4+1);
        g.drawImage(image, x+1, y+1, w/4, h/4, this);

        // horizontally flipped
        g.drawImage(image, x+w, y, x+2*w, y+h, w, 0, 0, h, this);

        // vertically flipped 
        g.drawImage(image, x+2*w, y, x+3*w, y+h, 0, h, w, 0, this);

        // enlarged; use -1 to indicate proportional height
        g.drawImage(image, x+3*w, y, 2*w, -1, this);
    }

    static public void main(String[] args) {
        if (args.length == 1) {
            new Main(args[0]);
        } else {
            System.err.println("usage: java Main <image file>");
        }
    }
}
