import java.awt.*;

class Main extends Frame {
    Main() {
        super("fillOval Example");
        setSize(400, 200);
        show();
    }

    public void paint(Graphics g) {
        int iSize = 50;
        Insets insets = this.getInsets();
        int startx = insets.left, starty = insets.top;
        int w = getSize().width-insets.left-insets.right;
        int h = getSize().height-insets.top-insets.bottom;
        Image image = createImage(iSize);

        for (int y=0; y<h; y += iSize) {
            for (int x=0; x<w; x += iSize) {
                g.drawImage(image, startx+x, starty+y, iSize, iSize, null);
            }
        }
    }

    Image createImage(int size) {
        Image im = createImage(size, size);
        Graphics g = im.getGraphics();
        Rectangle r = new Rectangle(size, size);

        g.setColor(getBackground());
        g.fillRect(0, 0, size, size);
        while (!r.isEmpty()) {
            int c = r.x * 2 * 63 / size;
            g.setColor(new Color(255-c, 150, c+150));
            g.fillOval(r.x, r.y, r.width, r.height);
            r.grow(-1, -1);
        }
        return im;
    }

    static public void main(String[] args) {
        new Main();
    }
}

