import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    int curX, curY, newX, newY;

    Main() {
        super("setXORMode Example");
        setSize(200, 200);

        addMouseMotionListener(new MouseMotionEventHandler());
        show();
    }

    class MouseMotionEventHandler extends MouseMotionAdapter {
        public void mouseMoved(MouseEvent evt) {
            newX = evt.getX();
            newY = evt.getY();
            repaint();
        }
    }

    void drawLines(Graphics g, int x, int y, int w, int h) {
        g.setXORMode(Color.green);
        g.setColor(Color.red);
        g.drawLine(0, 0, x, y);
        g.setColor(Color.green);
        g.drawLine(w, 0, x, y);
        g.setColor(Color.blue);
        g.drawLine(0, h, x, y);
        g.setColor(Color.yellow);
        g.drawLine(w, h, x, y);
        g.setColor(Color.black);
        g.fillOval(x-20, y-20, 40, 40);
    }

    public void update(Graphics g) {
        Insets insets = this.getInsets();
        int w = getSize().width-insets.left-insets.right;
        int h = getSize().height-insets.top-insets.bottom;

        // Erase old image.
        drawLines(g, curX, curY, w, h);
        // Paint new one.
        drawLines(g, newX, newY, w, h);
        curX = newX;
        curY = newY;
    }

    public void paint(Graphics g) {
        Insets insets = this.getInsets();
        int startx = insets.left, starty = insets.top;
        int w = getSize().width-insets.left-insets.right;
        int h = getSize().height-insets.top-insets.bottom;

        g.setPaintMode();
        g.setColor(Color.red);
        g.fillRect(startx, starty, w/3, h);
        g.setColor(Color.green);
        g.fillRect(startx+w/3, starty, w/3, h);
        g.setColor(Color.blue);
        g.fillRect(startx+w*2/3, starty, w/3, h);
        g.setColor(Color.black);
        g.fillRect(startx, starty+h/3, w, h/3);
        drawLines(g, newX=curX=w/2, newY=curY=h/2, w, h);
    }

    static public void main(String[] args) {
        new Main();
    }
}
