import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements AdjustmentListener {
    MainCanvas cv = new MainCanvas();
    Scrollbar sb = new Scrollbar(Scrollbar.VERTICAL, 0, 40, 0, 100);

    Main() {
        super("translate Example");
        add(cv, BorderLayout.CENTER);
        add(sb, BorderLayout.EAST);

        sb.addAdjustmentListener(this);
        setSize(200, 200);
        show();
    }

    public void adjustmentValueChanged(AdjustmentEvent evt) {
	System.out.println(sb.getValue());
        cv.setOrigin(0, -cv.getSize().height * sb.getValue() / 100);
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Component {
    int thick;
    double[] values = new double[100];
    int curX, curY;
    int originX, originY;

    MainCanvas() {
        for (int i=0; i<values.length; i++) {
            values[i] = Math.random();
        }
        addMouseListener(new MouseEventHandler());
    }

    void setOrigin(int x, int y) {
        originX = x;
        originY = y;
        repaint();
    }

    public void paint(Graphics g) {
        int w = getSize().width;
        thick = getSize().height*2/values.length;

        g.translate(originX, originY);
        for (int i=0; i<values.length; i++) {
            int c = (int)(Math.floor(255 * values[i]));
            if (curY >= i * thick && curY < (i+1) * thick) {
                g.setColor(Color.red);
            } else {
                g.setColor(new Color(c, c, c));
            }
            g.fillRect(0, i * thick, (int)(w * values[i]), thick);
        }
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            curX = evt.getX() - originX;
            curY = evt.getY() - originY;
            repaint();
        }
    }
}
