import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements ActionListener {
    Button centerButton;
    GridBagLayout gbl = new GridBagLayout();

    Main() {
        super("insets Example");
        GridBagConstraints c = new GridBagConstraints();

        setLayout(gbl);
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1;
        c.weighty = 1;

        makeButton(this, "-top", c, 1, 0);
        makeButton(this, "+top", c, 2, 0);
        makeButton(this, "+left", c, 0, 1);
        makeButton(this, "-left", c, 0, 2);
        makeButton(this, "-bottom", c, 1, 3);
        makeButton(this, "+bottom", c, 2, 3);
        makeButton(this, "+right", c, 3, 1);
        makeButton(this, "-right", c, 3, 2);

        // Make center button.
        c.gridwidth = c.gridheight = 2;
        c.fill = GridBagConstraints.BOTH;
        centerButton = makeButton(this, "T0 L0 B0 R0", c, 1, 1);

        setSize(200, 200);
        show();
    }

    // Returns the new button.
    Button makeButton(Container cont, String label, 
            GridBagConstraints c, int x, int y) {
        GridBagLayout gbl = (GridBagLayout)cont.getLayout();
        Button b = new Button(label);

        cont.add(b);
        c.gridx = x;
        c.gridy = y;
        gbl.setConstraints(b, c);
        b.addActionListener(this);
        return b;
    }

    public void actionPerformed(ActionEvent evt) {
        GridBagConstraints c = gbl.getConstraints(centerButton);
        String s = evt.getActionCommand();
        int sign = s.charAt(0) == '+' ? 1 : -1;
    
        s = s.substring(1);
        if ("top".equals(s)) {
            c.insets.top += sign;
        } else if ("left".equals(s)) {
            c.insets.left += sign;
        } else if ("bottom".equals(s)) {
            c.insets.bottom += sign;
        } else if ("right".equals(s)) {
            c.insets.right += sign;
        }
        gbl.setConstraints(centerButton, c);
        centerButton.setLabel("T"+c.insets.top+" L"+c.insets.left
                              +" B"+c.insets.bottom+" R"+c.insets.right);
        invalidate();
        validate();
    }

    static public void main(String[] args) {
        new Main();
    }
}
