import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements ItemListener {
    GridBagLayout gbl = new GridBagLayout();
    Main() {
        super("getLayoutOrigin Example");
        GridBagConstraints c = new GridBagConstraints();
        Checkbox cb;

        c.fill = GridBagConstraints.BOTH;
        setLayout(gbl);
        add(cb = new Checkbox("weightx = 0.0"));
        gbl.setConstraints(cb, c);
        cb.addItemListener(this);
        add(cb = new Checkbox("weighty = 0.0"));
        gbl.setConstraints(cb, c);
        cb.addItemListener(this);

        setSize(300, 100);
        show();
    }

    public void paint(Graphics g) {
        Insets insets = this.getInsets();
        int x = insets.left, y = insets.top;
        int dotSize = 20;
        Point p = gbl.getLayoutOrigin();

        g.setColor(Color.black);
        g.fillRect(x, y, getSize().width-x-insets.right, 
                   getSize().height-y-insets.bottom);
        g.setColor(Color.red);
        g.fillOval(p.x-dotSize/2, p.y-dotSize/2, dotSize, dotSize);
    }

    public void itemStateChanged(ItemEvent evt) {
        Checkbox cb = (Checkbox)evt.getSource();
        GridBagConstraints c = gbl.getConstraints(cb);
        String label = cb.getLabel().substring(0, 7);
        int val = cb.getState() ? 1 : 0;

        if (label.equals("weightx")) {
            c.weightx = val;
        } else {
            c.weighty = val;
        }
        cb.setLabel(label + " = " + val + ".0");
        gbl.setConstraints(cb, c);
        invalidate();
        validate();
        repaint();
    }

    static public void main(String[] args) {
        new Main();
    }
}
