import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;

class Main extends Frame implements ActionListener, ItemListener {
    MenuBar mb = new MenuBar();
    boolean delsc = false;

    Main() {
        super("deleteShortcut Example");
        Menu m = new Menu("File");
        MenuItem mi;

        mi = new MenuItem("New", new MenuShortcut(KeyEvent.VK_N));
        mi.setActionCommand("New");  // required for shortcut
        m.add(mi);
        
        mi = new MenuItem("Open...", new MenuShortcut(KeyEvent.VK_O));
        mi.setActionCommand("Open"); // required for shortcut
        m.add(mi);

        m.add("-");

        m.add(mi = new MenuItem("Exit", new MenuShortcut(KeyEvent.VK_E)));
        mi.setActionCommand("Exit"); // required for shortcut
        mb.add(m);

        // Add listener for menu (and its menu items)
        m.addActionListener(this);

        // Set the menu bar on the frame.
        setMenuBar(mb);

        // Add controls for viewing and deleting shortcuts
        Panel p = new Panel(new GridLayout(1, 0));
        CheckboxGroup cg = new CheckboxGroup();
        Checkbox del = new Checkbox("Delete", false, cg);
        Checkbox find = new Checkbox("Find", true, cg);
        del.addItemListener(this);
        find.addItemListener(this);

        TextField tf = new TextField("");
        p.add(del);
        p.add(find);
        p.add(tf);
        tf.addActionListener(this);

        add(new TextArea("Text area"), BorderLayout.CENTER);
        add(p, BorderLayout.SOUTH);

        setSize(100, 100);    
        show();
    }

    void printShortcuts(String msg, MenuBar mb) {
        System.out.print(msg);
        for (Enumeration sc = mb.shortcuts(); 
             sc.hasMoreElements();
             ) {
            System.out.print(sc.nextElement() + " ");
        }
        System.out.println("");
    }

    public void actionPerformed(ActionEvent evt) {
        if (evt.getSource() instanceof MenuItem) {
            System.out.println(evt.getActionCommand());
        } else if (evt.getSource() instanceof TextField) {
            String sc = evt.getActionCommand();
            MenuShortcut target = new MenuShortcut(sc.charAt(0));
            if (delsc) {
                printShortcuts("Before delete: ", mb);
                mb.deleteShortcut(target);
                printShortcuts("After delete: ", mb);
            } else {
                System.out.println(mb.getShortcutMenuItem(target));
            }
        }
    }

    public void itemStateChanged(ItemEvent evt) {
        delsc = (evt.getItem().equals("Delete"));
    }

    static public void main(String[] args) {
        new Main();
    }
}
