import java.awt.*;
import java.awt.event.*;

class Main extends Frame 
    implements ActionListener {
    Main() {
        super("MenuShortcut Example");
        Menu m = new Menu("File");

        // Create menu items with shortcuts
        MenuItem mi = 
            new MenuItem("Edit", new MenuShortcut(KeyEvent.VK_E));
        mi.setActionCommand("Edit");  // required for shortcut
        m.add(mi);
        mi = new MenuItem("Save", 
                          new MenuShortcut(KeyEvent.VK_S, true)); // Shift
        mi.setActionCommand("Save");  // required for shortcut
        m.add(mi);
        
        // Add listener for menu (and its menu items)
        m.addActionListener(this);

        // Set the menu bar on the frame.
        MenuBar mb = new MenuBar();
        mb.add(m);
        setMenuBar(mb);

        setSize(100, 100);    
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        System.out.println(evt.getActionCommand());
    }

    static public void main(String[] args) {
        new Main();
    }
}
