import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ItemListener {
    Choice policyCh = new Choice();

    ScrollPane sp = new ScrollPane(ScrollPane.SCROLLBARS_ALWAYS);
    CircleComponent circle = new CircleComponent();

    Main() {
        super("SCROLLBARS_ALWAYS Example");

        // Initialize policy choice.
        policyCh.addItem("SCROLLBARS_ALWAYS");
        policyCh.addItem("SCROLLBARS_AS_NEEDED");
        policyCh.addItem("SCROLLBARS_NEVER");
        policyCh.select(0);
        policyCh.addItemListener(this);

        // Layout and show components.
        sp.add(circle);
        add(sp, BorderLayout.CENTER);
        add(policyCh, BorderLayout.NORTH);

        setSize(200, 150);
        show();
    }

    public void itemStateChanged(ItemEvent evt) {
        int p = sp.getScrollbarDisplayPolicy();

        if ("SCROLLBARS_ALWAYS".equals(evt.getItem())) {
            p = ScrollPane.SCROLLBARS_ALWAYS;
        } else if ("SCROLLBARS_AS_NEEDED".equals(evt.getItem())) {
            p = ScrollPane.SCROLLBARS_AS_NEEDED;
        } else if ("SCROLLBARS_NEVER".equals(evt.getItem())) {
            p = ScrollPane.SCROLLBARS_NEVER;
        }
        if (sp.getScrollbarDisplayPolicy() != p) {
            // Create a new scrollpane with the new display policy.
            remove(sp);
            sp = new ScrollPane(p);
            sp.add(circle);
            add(sp, BorderLayout.CENTER);
            validate();

        System.out.println(sp.getHAdjustable());
        System.out.println(sp.getVAdjustable());
        }
    }

    public static void main(String args[]) {
        new Main();
    }
}

class CircleComponent extends Canvas {
    public Dimension getPreferredSize() {
        return new Dimension(200, 200);
    }

    public void paint(Graphics g) {
        g.setColor(Color.lightGray);
        g.fillOval(0, 0, 200, 200);
        g.setColor(Color.black);
        g.drawOval(0, 0, 200, 200);
    }
}
