import java.awt.*;

class Square extends Rectangle {
    public Square(int x, int y, int length) {
        super(x, y, length, length);
    }
}

class Circle implements Shape {
    int x, y, radius;

    // circle centered at x, y, with radius 'radius'
    public Circle(int x, int y, int radius) {
        this.x = x;
        this.y = y;
        this.radius = radius;
    }
    
    public Rectangle getBounds() {
        // (x, y) is center of circle; offset x and y by circle's radius
        return new Rectangle(x-radius, y-radius, radius*2, radius*2);
    }
}


class Main {
    public static void main(String[] args) {
        Shape s1 = new Square(15, 20, 50);
        Shape s2 = new Rectangle(65, 20, 25, 30);
        Shape s3 = new Circle(115, 20, 10);

        System.out.println("square: " + s1.getBounds());
        System.out.println("rectangle: " + s2.getBounds());
        System.out.println("circle: " + s3.getBounds());
    }
}
