import java.beans.*;
import java.lang.reflect.*;

public class BeanBeanInfo extends SimpleBeanInfo {
    public PropertyDescriptor[] getPropertyDescriptors() {
        PropertyDescriptor pd[] = new PropertyDescriptor[3];

        try {
            // The getter and setter methods are derived from the property name.
            pd[0] = new PropertyDescriptor("property1", Bean.class);

            // The names of the getter and setter methods are supplied.
            pd[1] = new PropertyDescriptor("property2", Bean.class,
                "getProperty2", "setProperty2");

            // The Method objects of the getter and setter methods are supplied.
            Class[] getArgs = {};

            // The getter method must not take any parameters.
            Method getter = Bean.class.getMethod("getProperty3", getArgs);

            // The setter must take one parameter and it must have the
            // same type as returned by the getter method.
            Class[] setArgs = {getter.getReturnType()};
            Method setter = Bean.class.getMethod("setProperty3", setArgs);
            pd[2] = new PropertyDescriptor("property3", getter, setter);

            return pd;
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        } catch (IntrospectionException e) {
            e.printStackTrace();
        }
        return null;
    }
}
