package classexample;

import java.awt.*;
import java.beans.*;
import java.util.*;

public class BeanPriceListener implements PropertyChangeListener, VetoableChangeListener {
    Vector priceChangeLog = new Vector();

    // If the price difference is too high, veto it.
    public void vetoableChange(PropertyChangeEvent evt) 
        throws PropertyVetoException {
        float oldPrice = ((Float)evt.getOldValue()).floatValue();
        float newPrice = ((Float)evt.getNewValue()).floatValue();

        if (newPrice - oldPrice > .5f) {
            throw(new PropertyVetoException("Too Much!", evt));
        }
    }

    // Save the new price.
    public void propertyChange(PropertyChangeEvent evt) {
        priceChangeLog.addElement(evt.getNewValue());
    }
}

