import java.awt.*;
import java.awt.event.*;
import java.beans.*;

public class ColorCustomEditor extends Panel implements AdjustmentListener {
    Color curColor;
    PropertyEditor pe;
    Scrollbar hSbar = new Scrollbar(Scrollbar.VERTICAL, 500, 1, 0, 1000);
    Scrollbar sSbar = new Scrollbar(Scrollbar.HORIZONTAL, 500, 1, 0, 1000);
    Scrollbar bSbar = new Scrollbar(Scrollbar.VERTICAL, 500, 1, 0, 1000);

    public ColorCustomEditor(PropertyEditor pe, Color c) {
        if (c == null) {
            c = Color.gray;
        }
        float[] hsbvals = 
            Color.RGBtoHSB(c.getRed(), c.getGreen(), c.getBlue(), null);

        this.pe = pe;
        curColor = c;
        setLayout(new BorderLayout());

        hSbar.addAdjustmentListener(this);
        sSbar.addAdjustmentListener(this);
        bSbar.addAdjustmentListener(this);
        hSbar.setValue((int)Math.round(hsbvals[0]*1000));
        sSbar.setValue((int)Math.round(hsbvals[1]*1000));
        bSbar.setValue((int)Math.round(hsbvals[2]*1000));
        add(hSbar, BorderLayout.WEST);
        add(sSbar, BorderLayout.SOUTH);
        add(bSbar, BorderLayout.EAST);
    }

    public Dimension getPreferredSize() {
        return new Dimension(100, 100);
    }

    public void paint(Graphics g) {
        g.setColor(curColor);
        g.fillRect(0, 0, getSize().width, getSize().height);
    }

    public void adjustmentValueChanged(AdjustmentEvent evt) {
        curColor = Color.getHSBColor(
            hSbar.getValue()/1000.0f,
            sSbar.getValue()/1000.0f,
            bSbar.getValue()/1000.0f);
        pe.setValue(curColor);
        repaint();
    }
}
