import java.awt.*;
import java.awt.event.*;

public class MessageFrame extends Frame implements ActionListener {
    MessageFrame(String msg) {
        super("Message");

        // Create the components.
        Button b = new Button("OK");
        Label l = new Label(msg, Label.CENTER) {
            // This adds some space around the text.
            public Dimension getPreferredSize() {
                Dimension d = super.getPreferredSize();
                return new Dimension(d.width+40, d.height+40);
            }
        };

        // Listen for events.
        b.addActionListener(this);
        addWindowListener(new WindowEventHandler());

        // Layout components.
        add(l, BorderLayout.NORTH);
        add(b, BorderLayout.SOUTH);

        pack();
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        dispose();
    }

    class WindowEventHandler extends WindowAdapter {
        public void windowClosing(WindowEvent evt) {
            dispose();
        }
    }
}
